// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from alpha_msgs:msg/JointData.idl
// generated code does not contain a copyright notice
#include "alpha_msgs/msg/detail/joint_data__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
alpha_msgs__msg__JointData__init(alpha_msgs__msg__JointData * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    alpha_msgs__msg__JointData__fini(msg);
    return false;
  }
  // data
  return true;
}

void
alpha_msgs__msg__JointData__fini(alpha_msgs__msg__JointData * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // data
}

bool
alpha_msgs__msg__JointData__are_equal(const alpha_msgs__msg__JointData * lhs, const alpha_msgs__msg__JointData * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // data
  for (size_t i = 0; i < 5; ++i) {
    if (lhs->data[i] != rhs->data[i]) {
      return false;
    }
  }
  return true;
}

bool
alpha_msgs__msg__JointData__copy(
  const alpha_msgs__msg__JointData * input,
  alpha_msgs__msg__JointData * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // data
  for (size_t i = 0; i < 5; ++i) {
    output->data[i] = input->data[i];
  }
  return true;
}

alpha_msgs__msg__JointData *
alpha_msgs__msg__JointData__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  alpha_msgs__msg__JointData * msg = (alpha_msgs__msg__JointData *)allocator.allocate(sizeof(alpha_msgs__msg__JointData), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(alpha_msgs__msg__JointData));
  bool success = alpha_msgs__msg__JointData__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
alpha_msgs__msg__JointData__destroy(alpha_msgs__msg__JointData * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    alpha_msgs__msg__JointData__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
alpha_msgs__msg__JointData__Sequence__init(alpha_msgs__msg__JointData__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  alpha_msgs__msg__JointData * data = NULL;

  if (size) {
    data = (alpha_msgs__msg__JointData *)allocator.zero_allocate(size, sizeof(alpha_msgs__msg__JointData), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = alpha_msgs__msg__JointData__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        alpha_msgs__msg__JointData__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
alpha_msgs__msg__JointData__Sequence__fini(alpha_msgs__msg__JointData__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      alpha_msgs__msg__JointData__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

alpha_msgs__msg__JointData__Sequence *
alpha_msgs__msg__JointData__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  alpha_msgs__msg__JointData__Sequence * array = (alpha_msgs__msg__JointData__Sequence *)allocator.allocate(sizeof(alpha_msgs__msg__JointData__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = alpha_msgs__msg__JointData__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
alpha_msgs__msg__JointData__Sequence__destroy(alpha_msgs__msg__JointData__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    alpha_msgs__msg__JointData__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
alpha_msgs__msg__JointData__Sequence__are_equal(const alpha_msgs__msg__JointData__Sequence * lhs, const alpha_msgs__msg__JointData__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!alpha_msgs__msg__JointData__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
alpha_msgs__msg__JointData__Sequence__copy(
  const alpha_msgs__msg__JointData__Sequence * input,
  alpha_msgs__msg__JointData__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(alpha_msgs__msg__JointData);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    alpha_msgs__msg__JointData * data =
      (alpha_msgs__msg__JointData *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!alpha_msgs__msg__JointData__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          alpha_msgs__msg__JointData__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!alpha_msgs__msg__JointData__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
