// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from alpha_msgs:msg/JointData.idl
// generated code does not contain a copyright notice

#ifndef ALPHA_MSGS__MSG__DETAIL__JOINT_DATA__STRUCT_HPP_
#define ALPHA_MSGS__MSG__DETAIL__JOINT_DATA__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__alpha_msgs__msg__JointData __attribute__((deprecated))
#else
# define DEPRECATED__alpha_msgs__msg__JointData __declspec(deprecated)
#endif

namespace alpha_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct JointData_
{
  using Type = JointData_<ContainerAllocator>;

  explicit JointData_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<double, 5>::iterator, double>(this->data.begin(), this->data.end(), 0.0);
    }
  }

  explicit JointData_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    data(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<double, 5>::iterator, double>(this->data.begin(), this->data.end(), 0.0);
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _data_type =
    std::array<double, 5>;
  _data_type data;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__data(
    const std::array<double, 5> & _arg)
  {
    this->data = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    alpha_msgs::msg::JointData_<ContainerAllocator> *;
  using ConstRawPtr =
    const alpha_msgs::msg::JointData_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<alpha_msgs::msg::JointData_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<alpha_msgs::msg::JointData_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      alpha_msgs::msg::JointData_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<alpha_msgs::msg::JointData_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      alpha_msgs::msg::JointData_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<alpha_msgs::msg::JointData_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<alpha_msgs::msg::JointData_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<alpha_msgs::msg::JointData_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__alpha_msgs__msg__JointData
    std::shared_ptr<alpha_msgs::msg::JointData_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__alpha_msgs__msg__JointData
    std::shared_ptr<alpha_msgs::msg::JointData_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const JointData_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->data != other.data) {
      return false;
    }
    return true;
  }
  bool operator!=(const JointData_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct JointData_

// alias to use template instance with default allocator
using JointData =
  alpha_msgs::msg::JointData_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace alpha_msgs

#endif  // ALPHA_MSGS__MSG__DETAIL__JOINT_DATA__STRUCT_HPP_
