// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from alpha_msgs:msg/JointData.idl
// generated code does not contain a copyright notice

#ifndef ALPHA_MSGS__MSG__DETAIL__JOINT_DATA__TRAITS_HPP_
#define ALPHA_MSGS__MSG__DETAIL__JOINT_DATA__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "alpha_msgs/msg/detail/joint_data__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace alpha_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const JointData & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: data
  {
    if (msg.data.size() == 0) {
      out << "data: []";
    } else {
      out << "data: [";
      size_t pending_items = msg.data.size();
      for (auto item : msg.data) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const JointData & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data.size() == 0) {
      out << "data: []\n";
    } else {
      out << "data:\n";
      for (auto item : msg.data) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const JointData & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace alpha_msgs

namespace rosidl_generator_traits
{

[[deprecated("use alpha_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const alpha_msgs::msg::JointData & msg,
  std::ostream & out, size_t indentation = 0)
{
  alpha_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use alpha_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const alpha_msgs::msg::JointData & msg)
{
  return alpha_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<alpha_msgs::msg::JointData>()
{
  return "alpha_msgs::msg::JointData";
}

template<>
inline const char * name<alpha_msgs::msg::JointData>()
{
  return "alpha_msgs/msg/JointData";
}

template<>
struct has_fixed_size<alpha_msgs::msg::JointData>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<alpha_msgs::msg::JointData>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<alpha_msgs::msg::JointData>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ALPHA_MSGS__MSG__DETAIL__JOINT_DATA__TRAITS_HPP_
